// Java program to demonstrate working of
// comparator based priority queue constructor
import java.util.*;
 
public class PriQueueEx3 {
  public static void main(String[] args){
    // Creating Priority queue constructor having
    // initial capacity=5 and a StudentComparator instance
    // as its parameters
    PriorityQueue<Student> pq = new
       PriorityQueue<Student>(5, new StudentComparator());
                 
    // Invoking a parameterized Student constructor with
    // name and cgpa as the elements of queue
    Student student1 = new Student("Nandini", 3.6);
                 
    // Adding a student object containing fields
    // name and cgpa to priority queue
    pq.add(student1);
    Student student2 = new Student("Anmol", 3.2);
    pq.add(student2);        
    Student student3 = new Student("Palak", 4.0);
    pq.add(student3);
    pq.add(new Student("Bobbi", 3.75));
                 
    // Printing names of students in priority order,poll()
    // method is used to access the head element of queue
    System.out.println("Students served in their priority order");
    System.out.println("this means here, highest GPA first");
                 
    while (!pq.isEmpty()) { 
      Student st = pq.poll();
      System.out.println(st.getName() + " <" + st.getGPA() + ">"); 
    }
  }
}

class StudentComparator implements Comparator<Student>{           
  // Overriding compare()method of Comparator
  // for descending order of cgpa 
  // (highest number is highest priority)
  public int compare(Student s1, Student s2) {
    // this one compares for max heap
    if (s1.getGPA() < s2.getGPA()) return 1;
    else if (s1.getGPA() > s2.getGPA()) return -1;
    return 0;// if gpas are ==
  }
}
 
class Student {
  private String name;
  private double gpa;
         
  // A parameterized student constructor
  public Student(String n, double g) {
    this.name = n;
    this.gpa = g;
  }
     
  public double getGPA() { return this.gpa; }
  public String getName() { return this.name; }
}
 