// Java program to demonstrate working of
// comparator based priority queue constructor
import java.util.*;
 
public class PriQueueEx4 {
  public static void main(String[] args){
    // Creating Priority queue constructor having
    PriorityQueue<Pair> pq = new PriorityQueue<Pair>(50, new PairComparator());
                 
    // Invoking a parameterized Student constructor with
    // name and cgpa as the elements of queue
    Pair p1 = new Pair(1, "durham");
    pq.add(p1);          

    pq.add(new Pair(5,"apex"));
    pq.add(new Pair(12,"raleigh"));
    pq.add(new Pair(2,"mebane"));
    pq.add(new Pair(7,"sanford"));

                 
    // Printing names of nodes in priority order,poll()
    // method is used to access the head element of queue
    System.out.println("Nodes served in their priority order");
    System.out.println("here, this means smallest priority number first");
                 
    while (!pq.isEmpty()) { 
      Pair p = pq.poll(); // getMin then delMin ops
      System.out.println(p.getName() + " <" + p.getPri() + ">"); 
      // for Dijkstra's alg you would pull a pair
      // out of the priority queue, and then
      // take the node name out of the pair with getName()
      // and then use the hashmap of nodes to get the node 
      // object for the name
    }
  }
}

class PairComparator implements Comparator<Pair>{           
  public int compare(Pair p1, Pair p2) {
    // this one compares for min heap
    if (p1.getPri() > p2.getPri()) return 1;
    else if (p1.getPri() < p2.getPri()) return -1;
    return 0;// if priorities are ==, i.e. not < and not >
  }
}
 
class Pair {
  private String name;
  private int priority;
  
  Pair(int p, String n) { this.name=n; this.priority=p; }
  
  public int getPri() { return this.priority; }
  public String getName() { return this.name; }
}
         