import java.util.*;  

// Queue interface
/*
   add(): an enque, it is used to add an element at the tail of the queue. 
      The element to be inserted is passed as the parameter. 
      The method throws an exception if the operation is unsuccessful, 
        and returns true if the operation is successful.
   offer(): an enque, is used to add an element at the tail of the queue. 
      The element to be inserted is passed as the parameter. 
      The method returns false if the operation is unsuccessful, and 
        returns true if the operation is successful.
   remove(): a deque, it returns the head of the queue and removes it. 
      The method throws an exception if the queue is empty.
   poll(): a deque, it returns the head of the queue and removes it. 
      It returns null if the queue is empty.
   peek(): a front, it returns the head of the queue without removing it. 
      It returns null if the queue is empty.
   element(): a front, it returns the head of the queue without removing it. 
      It throws an exception if the queue is empty.
   size(): returns the number of elements in the queue.
   isEmpty(): returns true if the queue is empty, otherwise it returns false.
*/

public class QueueEx1 {  
  public static void main(String args[]){ 
    // here keys are integer, associated values are String 
    Queue<String> que = new LinkedList<String>(); //Creating linked list impl
       
    try { que.add("Mango"); } catch (Exception e) {
      System.out.println("oops... failed to enque with add"); 
    } 
    if (que.offer("Apple")) { System.out.println("able to enque with offer"); } 
      else { System.out.println("failed to enque with offer"); 
    }
    que.add("Banana");   
    que.add("Grapes");  
    
    System.out.println(que.size());
    System.out.println(que.peek());
    System.out.println(que.size());
    System.out.println(que.remove());
    System.out.println(que.size());
    System.out.println(que.element());
    System.out.println(que.size());

   
    
    // Note this sort of HashMap can also be done by Array...
    // but what are the downsides to doing this?
    //
    // String[] map = New Array[5000] ; <--- waste a lot of space to save a few items
    // map[1] = "Mango";
    // map[2] = "Apple"; // etc...
    /*       
    System.out.println("Iterating Hashmap...");  
    for(Map.Entry m : map.entrySet()){    
      System.out.println(m.getKey()+":> "+m.getValue());    
    }  
    */
    
  }  
}  